# class Crystal::Macros::MetaVar

- Crystal::Macros::MetaVar
- Crystal::Macros::ASTNode
- Reference
- Object

##
Overview

A fictitious node representing a variable or instance variable, together with type information.

##
Defined in:

##
Instance Method Summary

- #annotation(type : TypeNode) : Annotation | NilLiteral

  Returns the last `Annotation` with the given `#type` attached to this variable or `NilLiteral` if there are none.

- #annotations(type : TypeNode) : Crystal::Macros::ArrayLiteral(Annotation)

  Returns an array of annotations with the given `#type` attached to this variable, or an empty `ArrayLiteral` if there are none.

- #default_value : ASTNode

  Returns the default value of this variable.

- #has_default_value? : BoolLiteral

  Returns whether this variable has a default value (which can in turn be `nil`).

- #name : MacroId

  Returns the name of this variable.

- #type : TypeNode | NilLiteral

  Returns the type of this variable, if known, or `nil`.

### Instance methods inherited from class `Crystal::Macros::ASTNode`

!=(other : ASTNode) : BoolLiteral !=, ==(other : ASTNode) : BoolLiteral ==, class_name : StringLiteral class_name, column_number : StringLiteral | NilLiteral column_number, end_column_number : StringLiteral | NilLiteral end_column_number, end_line_number : StringLiteral | NilLiteral end_line_number, filename : StringLiteral | NilLiteral filename, id : MacroId id, line_number : StringLiteral | NilLiteral line_number, raise(message) : NoReturn raise, stringify : StringLiteral stringify, symbolize : SymbolLiteral symbolize

### Instance methods inherited from class `Reference`

==(other : self)
==(other : JSON::Any)
==(other : YAML::Any)
==(other) ==, dup dup, hash(hasher) hash, inspect(io : IO) : Nil inspect, object_id : UInt64 object_id, pretty_print(pp) : Nil pretty_print, same?(other : Reference)
same?(other : Nil) same?, to_s(io : IO) : Nil to_s

### Constructor methods inherited from class `Reference`

new new

### Instance methods inherited from class `Object`

!=(other) !=, !~(other) !~, ==(other) ==, ===(other : JSON::Any)
===(other : YAML::Any)
===(other) ===, =~(other) =~, __crystal_pseudo_! : Bool __crystal_pseudo_!, __crystal_pseudo_as(type : Class) __crystal_pseudo_as, __crystal_pseudo_as?(type : Class) __crystal_pseudo_as?, __crystal_pseudo_is_a?(type : Class) : Bool __crystal_pseudo_is_a?, __crystal_pseudo_nil? : Bool __crystal_pseudo_nil?, __crystal_pseudo_responds_to?(name : Symbol) : Bool __crystal_pseudo_responds_to?, class class, dup dup, hash(hasher)
hash hash, inspect : String
inspect(io : IO) : Nil inspect, itself itself, not_nil! not_nil!, pretty_inspect(width = 79, newline = "\n", indent = 0) : String pretty_inspect, pretty_print(pp : PrettyPrint) : Nil pretty_print, tap(&) tap, to_json(io : IO)
to_json to_json, to_pretty_json(indent : String = " ")
to_pretty_json(io : IO, indent : String = " ") to_pretty_json, to_s : String
to_s(io : IO) : Nil to_s, to_yaml(io : IO)
to_yaml to_yaml, try(&) try, unsafe_as(type : T.class) forall T unsafe_as

### Class methods inherited from class `Object`

from_json(string_or_io, root : String)
from_json(string_or_io) from_json, from_yaml(string_or_io : String | IO) from_yaml

##
Instance Method Detail

def annotation(type : TypeNode) : Annotation | NilLiteral #

Returns the last `Annotation` with the given `#type` attached to this variable or `NilLiteral` if there are none.

def annotations(type : TypeNode) : Crystal::Macros::ArrayLiteral(Annotation) #

Returns an array of annotations with the given `#type` attached to this variable, or an empty `ArrayLiteral` if there are none.

def default_value : ASTNode #

Returns the default value of this variable. Note that if the variable doesn't have a default value, or the default value is `nil`, a `NilLiteral` will be returned. To distinguish between these cases, use `#has_default_value?`.

def has_default_value? : BoolLiteral #

Returns whether this variable has a default value (which can in turn be `nil`).

def name : MacroId #

Returns the name of this variable.

def type : TypeNode | NilLiteral #

Returns the type of this variable, if known, or `nil`.